/*
 * Copyright (c) 2017 Digital Bazaar, Inc. All rights reserved.
 */
'use strict';

module.exports = class JsonLdError extends Error {
  /**
   * Creates a JSON-LD Error.
   *
   * @param msg the error message.
   * @param type the error type.
   * @param details the error details.
   */
  constructor(message = 'An unspecified JSON-LD error occurred.', name = 'jsonld.Error', details = {}) {
    super(message);
    this.name = name;
    this.message = message;
    this.details = details;
  }

};